Attribute VB_Name = "modWinAPI"
#If Win32 Then
   '
   ' Public Constants
   '
   '
   Public Const EM_SETREADONLY = &HCF
   Public Const CB_SHOWDROPDOWN = &H14F
   Public Const LB_FINDSTRING = &H18F
   Public Const LB_FINDSTRINGEXACT = &H1A2
   Public Const WM_SETREDRAW = &HB
   Public Const CB_FINDSTRING = &H14C
   Public Const CB_FINDSTRINGEXACT = &H158
   Public Const LB_SETTABSTOPS = &H192
   '
   ' Windows API Declares
   '
   Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
   Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
   Declare Function GetFocus Lib "user32" () As Long
   Declare Function GetProfileInt Lib "kernel32" Alias "GetProfileIntA" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal nDefault As Long) As Long
   Declare Function GetProfileString Lib "kernel32" Alias "GetProfileStringA" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long) As Long
   Declare Function GetProfileSection Lib "kernel32" Alias "GetProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long) As Long
   Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
   Declare Function GetVersion Lib "kernel32" () As Long
   Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
   Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Integer, lParam As Any) As Long
   Declare Function WinHelp Lib "user32" Alias "WinHelpA" (ByVal hWnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData As Long) As Long
   Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, lpString As Any, ByVal lpFileName As String) As Long
   Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
   Declare Function WriteProfileSection Lib "kernel32" Alias "WriteProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String) As Long
   Declare Function WriteProfileString Lib "kernel32" Alias "WriteProfileStringA" (ByVal lpszSection As String, ByVal lpszKeyName As String, ByVal lpszString As String) As Long
   
#Else
   '
   ' Public Constants
   '
   Public Const WM_USER = &H400
   Public Const EM_SETREADONLY = (WM_USER + 31)
   Public Const CB_SHOWDROPDOWN = (WM_USER + 15)
   Public Const LB_FINDSTRING = (WM_USER + 16)
   Public Const CB_FINDSTRING = (WM_USER + 12)
   Public Const WM_SETREDRAW = &HB
   Public Const LB_SETTABSTOPS = (WM_USER + 19)
   '
   ' Windows API
   '
   Declare Function GetModuleHandle Lib "Kernel" (ByVal FileName As String) As Integer
   Declare Function GetFocus% Lib "User" ()
   Declare Function GetWindowText Lib "User" (ByVal hWnd As Integer, ByVal sString As String, ByVal iLen As Integer) As Integer
   Declare Function IsWindow Lib "User" (ByVal hWnd As Integer) As Integer
   'Declare Function SetFocusAPI Lib "User" Alias "SetFocus" (ByVal hWnd As Integer) As Integer
   'Declare Function GetWindowLong Lib "User" (ByVal hWnd As Integer, ByVal iIndex As Integer) As Long
   'Declare Function SetWindowLong Lib "User" (ByVal hWnd As Integer, ByVal iIndex As Integer, ByVal lValue As Long) As Long
   Declare Function SendMessage& Lib "User" (ByVal hWnd%, ByVal wMsg%, ByVal wParam%, lParam As Any)
   Declare Function PostMessage Lib "User" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, lParam As Long) As Integer
   Declare Function GetSystemDirectory Lib "Kernel" (ByVal strBuffer As String, ByVal intSize As Integer) As Integer
   Declare Function GetFreeSpace Lib "Kernel" (ByVal wFlags As Integer) As Long
   Declare Function GetWinFlags Lib "Kernel" () As Long
   Declare Function GetTempFileName Lib "Kernel" (ByVal cDrive As Integer, ByVal sPrefix As String, ByVal iUnique As Integer, ByVal sTempFile As String) As Integer
   
   ' User Profile Routines
   Declare Function GetProfileInt Lib "Kernel" (ByVal strApplicationName As String, ByVal strKeyName As String, ByVal intNORMAL As Integer) As Integer
   Declare Function GetProfileString Lib "Kernel" (ByVal strApplicationName As String, ByVal strKeyName As String, ByVal strNORMAL As String, ByVal strReturnedString As String, ByVal intSize As Integer) As Integer
   Declare Function WriteProfileString Lib "Kernel" (ByVal strApplicationName As String, ByVal strKeyName As String, ByVal strString As String) As Integer
   Declare Function GetPrivateProfileInt Lib "Kernel" (ByVal strApplicationName As String, ByVal strKeyName As String, ByVal intNORMAL As Integer, ByVal strFileName As String) As Integer
   Declare Function GetPrivateProfileString Lib "Kernel" (ByVal strApplicationName As String, ByVal strKeyName As Any, ByVal strNORMAL As String, ByVal strReturnedString As String, ByVal intSize As Integer, ByVal strFileName As String) As Integer
   Declare Function WritePrivateProfileString Lib "Kernel" (ByVal strApplicationName As String, ByVal strKeyName As String, ByVal strString As String, ByVal strFileName As String) As Integer
   Declare Function DelSectionPrivateProfileString Lib "Kernel" Alias "WritePrivateProfileString" (ByVal strApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal strFileName As String) As Integer
   
   ' GetWinFlags() Flags
   Public Const WF_PMODE = &H1
   Public Const WF_CPU286 = &H2
   Public Const WF_CPU386 = &H4
   Public Const WF_CPU486 = &H8
   Public Const WF_STANDARD = &H10
   Public Const WF_WIN286 = &H10
   Public Const WF_ENHANCED = &H20
   Public Const WF_WIN386 = &H20
   Public Const WF_CPU086 = &H40
   Public Const WF_CPU186 = &H80
   Public Const WF_LARGEFRAME = &H100
   Public Const WF_SMALLFRAME = &H200
   Public Const WF_80x87 = &H400
   
   Declare Function GetFreeSystemResources Lib "User" (ByVal intSysResource As Integer) As Integer
   
   ' GetFreeSystemResources Flags
   Public Const GFSR_SYSTEMRESOURCES = &H0
   Public Const GFSR_GDIRESOURCES = &H1
   Public Const GFSR_USERRESOURCES = &H2
   
   ' Commands to pass WinHelp()
   Public Const HELP_CONTEXT = &H1 '  Display topic in ulTopic
   Public Const HELP_QUIT = &H2    '  Terminate help
   Public Const HELP_INDEX = &H3   '  Display index
   Public Const HELP_HELPONHELP = &H4      '  Display help on using help
   Public Const HELP_SETINDEX = &H5        '  Set the current Index for multi index help
   Public Const HELP_KEY = &H101           '  Display topic for keyword in offabData
   Public Const HELP_MULTIKEY = &H201
   
   Declare Function WinHelp Lib "User" (ByVal hWnd As Integer, ByVal lpHelpFile As String, ByVal wCommand As Integer, dwData As Any) As Integer
   
   ' Version/System directory information for error system
   Declare Function GetVersion Lib "Kernel" () As Long
   Declare Function GetWindowsDirectory% Lib "Kernel" (ByVal lpBuffer$, ByVal nSize%)
   
   ' Window Functions
   Declare Function EnableWindow% Lib "User" (ByVal hWnd%, ByVal aBool%)
   Declare Function GetClassName Lib "User" (ByVal hWnd As Integer, ByVal lpClassName As String, ByVal nMaxCount As Integer) As Integer
   Declare Function ShowWindow Lib "User" (ByVal hWnd As Integer, ByVal nCmdShow As Integer) As Integer
   Declare Function LockWindowUpdate% Lib "User" (ByVal hwndLock%)
   Declare Sub UpdateWindow Lib "User" (ByVal hWnd%)
   
   ' Consts for Window Functions
   Public Const HIDE_WINDOW = &H0
#End If

Sub CBFindString(cboCombo As Control, sSearch As String)
   Dim lRet As Integer

   lRet = SendMessage(cboCombo.hWnd, CB_FINDSTRING, -1, ByVal sSearch)
   If lRet >= 0 Then
      cboCombo.ListIndex = lRet
   Else
      cboCombo.ListIndex = -1
   End If
End Sub

Function INIAppGet(sSection As String, sKey As String) As String
   Dim sString As String
   Dim iLen As Integer
      
   ' Retrieve Information from the App's INI File
   sString = Space$(255)
   iLen = GetPrivateProfileString(sSection, sKey, "", sString, Len(sString), gsIniName)
   sString = Left$(sString, iLen)

   INIAppGet = sString
End Function

Function INIGet(ByVal sSection As String, ByVal sKey As String, ByVal sIniName As String) As String
   Dim sString As String
   Dim iLen As Integer
      
   ' Retrieve Information from Any INI File
   sString = Space$(255)
   iLen = GetPrivateProfileString(sSection, sKey, "", sString, Len(sString), sIniName)
   sString = Left$(sString, iLen)

   INIGet = sString
End Function

Function INIWinGet(sSection As String, sKey As String) As String
   Dim sString As String
   Dim iLen As Integer
      
   ' Retrieve Information from WIN.INI
   sString = Space$(255)
   iLen = GetProfileString(sSection, sKey, "", sString, Len(sString))
   sString = Left$(sString, iLen)

   INIWinGet = sString
End Function

Sub TextReadOnly(txtControl As Control)
   Dim lReturn As Long

   lReturn = SendMessage(txtControl.hWnd, EM_SETREADONLY, 1, 0)
End Sub

