VERSION 4.00
Begin VB.Form frmItemList 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Product List"
   ClientHeight    =   3780
   ClientLeft      =   2130
   ClientTop       =   3720
   ClientWidth     =   5700
   ControlBox      =   0   'False
   BeginProperty Font 
      name            =   "MS Sans Serif"
      charset         =   0
      weight          =   700
      size            =   8.25
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4185
   Left            =   2070
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   ScaleHeight     =   3780
   ScaleWidth      =   5700
   Top             =   3375
   Width           =   5820
   Begin VB.ListBox lstItems 
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   400
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   2790
      Left            =   60
      Sorted          =   -1  'True
      TabIndex        =   1
      Top             =   60
      Width           =   5535
   End
   Begin Threed.SSPanel Panel3D1 
      Align           =   2  'Align Bottom
      Height          =   495
      Left            =   0
      TabIndex        =   0
      Top             =   3285
      Width           =   5700
      _Version        =   65536
      _ExtentX        =   10054
      _ExtentY        =   873
      _StockProps     =   15
      ForeColor       =   0
      BorderWidth     =   0
      BevelOuter      =   0
      BevelInner      =   2
      RoundedCorners  =   0   'False
      Begin VB.CommandButton cmdDelete 
         Caption         =   "&Delete"
         Enabled         =   0   'False
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   300
         Left            =   4740
         TabIndex        =   3
         Top             =   120
         Width           =   840
      End
      Begin VB.CommandButton cmdNew 
         Caption         =   "&New"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   300
         Left            =   3060
         TabIndex        =   5
         Top             =   120
         Width           =   840
      End
      Begin VB.CommandButton cmdRefresh 
         Caption         =   "&Refresh"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   300
         Left            =   120
         TabIndex        =   4
         Top             =   120
         Width           =   840
      End
      Begin VB.CommandButton cmdEdit 
         Caption         =   "&Edit"
         Enabled         =   0   'False
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   300
         Left            =   3900
         TabIndex        =   2
         Top             =   120
         Width           =   840
      End
   End
End
Attribute VB_Name = "frmItemList"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdDelete_Click()
   Dim lStmt As Long
   Dim iStatus As Integer
   Dim sSQL As String
   
   If MsgBox("Delete Product ?", vbYesNo + vbQuestion, "Delete") = vbYes Then
      sSQL = "DELETE FROM tblProducts "
      sSQL = sSQL & "WHERE lProd_id = " & glProdID
      
      iStatus = ODBCQuerySubmit(gldbc, lStmt, sSQL)
      If iStatus = True Then
         iStatus = lstItems.ListIndex
         lstItems.RemoveItem iStatus
         If iStatus <> 0 Then
            lstItems.ListIndex = iStatus - 1
         End If
      End If

      ' Free the Statment Handle
      iStatus = SQLFreeStmt(lStmt, SQL_DROP)
   End If
End Sub

Private Sub cmdEdit_Click()
   frmProd.Show
End Sub

Private Sub cmdNew_Click()
   glProdID = 0
   frmProd.Show
End Sub



Private Sub cmdRefresh_Click()
   lstItems.Clear
   Call FormInit
   Call ProdLoad
   lstItems.ListIndex = 0
End Sub

Private Sub ProdLoad()
   Const nPRODNAME% = 1
   Const nID% = 2
   Const nTYPE% = 3
   
   Dim bPerform As Integer
   Dim sSQL As String
   Dim lStmt As Long
   
   Dim sProductName As String
   Dim lProdID As Long
   Dim sType As String
   
   Dim sOldMsg As String
   
   sOldMsg = StatusProcess("Loading Products")
   
   sSQL = "SELECT sProdName, lProd_id, sProdType FROM tblProducts"
   ' Create statement handle & submit SQL
   bPerform = ODBCQuerySubmit(gldbc, lStmt, sSQL)
   Do While bPerform
      ' Get the next row of data
      bPerform = SQLFetch(lStmt)
     
      If bPerform = SQL_SUCCESS Then
         bPerform = True
         ' Get Company Name
         sProductName = ODBCData(lStmt, nPRODNAME)
   
         ' Get Company ID
         lProdID = CLng(ODBCData(lStmt, nID))
         
         ' Get Company Type
         sType = ODBCData(lStmt, nTYPE)
   
         ' Add to list box
         lstItems.AddItem sProductName & vbTab & sType
         lstItems.ItemData(lstItems.NewIndex) = lProdID
      Else
         bPerform = False
      End If
   Loop

   ' Clear the Statement handle
   bPerform = SQLFreeStmt(lStmt, SQL_DROP)
   
   Call StatusRestore(sOldMsg)
End Sub

Private Sub Form_Activate()
   Call StatusMsgShow(APP_MAIN_FORM_CAPTION)
   Call StatusIDShow("MAIN")
End Sub

Private Sub Form_Load()
   Call FormInit

   Call ProdLoad
End Sub

Private Sub FormInit()
   Dim lRet As Long
   
   Me.Top = 4
   Me.Left = 10

   lRet = SendMessage(lstItems.hWnd, LB_SETTABSTOPS, 1, 160&)
End Sub

Private Sub lstItems_Click()
   ' Store product ID into hidden label
   glProdID = lstItems.ItemData(lstItems.ListIndex)
   
   ' Enabled Edit Button & Open Product Menu Item
   cmdEdit.Enabled = True
   cmdDelete.Enabled = True
End Sub
Private Sub lstItems_DblClick()
   Call cmdEdit_Click
End Sub

